#include <Windows.h>
#include <tchar.h>
#include <stdio.h>
#include <atlrx.h>
#include <string>

using namespace std;

static BOOL IsVersionStringValid(LPCTSTR szVerStr)
{
	if (szVerStr == NULL)
		return FALSE;

	CAtlRegExp <> re;
	REParseError status = re.Parse( L"^{\\d+}\\.{\\d+}\\.{\\d+}\\.{\\d+}$" ); 
	CAtlREMatchContext<> mc_version;

	if (!re.Match( szVerStr, &mc_version))
	{
		return FALSE;
	}

	for (UINT nGroupIndex = 0; nGroupIndex < mc_version.m_uNumGroups; ++nGroupIndex)
	{
		const CAtlREMatchContext<>::RECHAR* szStart = 0, *szEnd = 0;
		mc_version.GetMatch(nGroupIndex, &szStart, &szEnd);

		if (_wtol(std::wstring(szStart, szEnd).c_str()) > 0xffff)
			return FALSE;
	}

	return TRUE;
}


int _tmain(int argc, TCHAR* argv[])
{
	BOOL is_version_string_valid = IsVersionStringValid(_T("10.10.10.10"));
	printf("%d\n", is_version_string_valid);
	return 0;
}